import matplotlib
# matplotlib.use('Agg')

import numpy as n
import matplotlib.pyplot as p

from scipy.optimize import curve_fit

data = n.loadtxt('line.txt')
x = data[:, 0]
y = data[:, 1]
s = data[:, 2]
p.errorbar(x,y,yerr=s,fmt='o')

def f(x, a, b):
    return a * x + b

# par, cov = curve_fit(f, x, y)
# par, cov = curve_fit(f, x, y, p0=n.array([0.7, 0.5]))
par,cov=curve_fit(f, x, y,
    p0 = n.array([0.7,0.5]),
    sigma = s,
    absolute_sigma = True)

# wypisanie parametrów fitu
print(par)
# wypisanie niepewnosci parametrów fitu
print(n.sqrt(n.diag(cov)))

# przygotowanie wspolrzednych x z danego zakresu
xpar = n.arange(-10, 10, 0.1)

# rysowanie dopasowanej zaleznosci
p.plot(xpar, f(xpar,par[0],par[1]))
#p.plot(xpar, f(xpar, *par))
p.plot(x, y, 'o')
p.show()

p.savefig('przyklad8.pdf')


