import matplotlib
# matplotlib.use('Agg')

import numpy as n
import matplotlib.pyplot as p

from scipy.optimize import curve_fit

data = n.loadtxt('line.txt')
x = data[:, 0]
y = data[:, 1]

p.plot(x, y, 'o')
p.show()

def f(x, a, b):
    return a * x + b

par, cov = curve_fit(f, x, y)

# wypisanie parametrów fitu
print(par)
# wypisanie niepewnosci parametrów fitu
print(n.sqrt(n.diag(cov)))

p.savefig('przyklad8.pdf')

